#ifndef BROMSCRIPT_ARGUMENTDATA_INCLUDED
#define BROMSCRIPT_ARGUMENTDATA_INCLUDED

#include "Variable.h"
#include "Instance.h"
#include "Function.h"
#include "Table.h"
#include "List.h"
#include "Converter.h"

namespace BromScript {
	class ArgumentData
	{
	public:
		static int GetCount();

		ArgumentData(void);
		~ArgumentData(void);

		int Count;
		Instance* BromScript;
		Function* Caller;
		
		void SetVariableData(List<Variable*>* vars);
		void InsertVariable(int index, Variable* var);
		void AddVariable(Variable* var);

		void Error(Scratch::CString msg);
		
		Variable::VariableType GetType(int index);
		bool CheckType(int index, Variable::VariableType type);
		bool CheckType(int index, Variable::VariableType type, bool throwerror);
		bool ErrorOccured();
		
		const char* GetString(int index);
		double GetNumber(int index);
		bool GetBool(int index);
		Table* GetTable(int index);
		Function* GetFunction(int index);
		Variable* GetVariable(int index);
		void* GetUserdata(int index, int datatype);

	private:
		List<Variable*> Vars;
	};
}

#endif