#ifndef BROMSCRIPT_SIF_INCLUDED
#define BROMSCRIPT_SIF_INCLUDED

#include "Scratch/Scratch.h"
#include "List.h"

#ifndef BS_FUNCTION
#define BS_FUNCTION(fn) BromScript::Variable* fn(BromScript::Instance* bsi, BromScript::ArgumentData* args)
#define BS_FUNCTION_CTOR(fn) void* fn(BromScript::Instance* bsi, BromScript::ArgumentData* args)
#define BS_FUNCTION_DTOR(fn) void fn(BromScript::Instance* bsi, void* data)
#define BS_ERRORFUNCTION(fn) void fn(BromScript::Instance* bsi, BromScript::CallStack* stack, int stacksize, const char* msg)
#endif

#ifndef null
#define null 0
#endif

#ifndef BROMSCRIPT_CURRENTVERSION
#define BROMSCRIPT_CURRENTVERSION 1
#endif

#ifndef PI
#define PI 3.14159265359
#endif

namespace BromScript {
	using namespace Scratch;

	class ByteReader;
	class ByteWriter;
	class CallStack;
	class Function;
	class Instance;
	class ExecuteData;
	class Executer;
	class Variable;
	class ArgumentData;
	class GarbageCollector;
	class Table;
	class MemberData;
	class Userdata;
	class MemberType;
	class CompilerException;

	typedef unsigned char byte;
	typedef Variable* (*BSFunction)(Instance* bsi, ArgumentData* args);
	typedef void* (*BSFunctionCtor)(Instance* bsi, ArgumentData* args);
	typedef void (*BSFunctionDtor)(Instance* bsi, void* data);
	typedef void (*ErrorFunction)(Instance* bsi, CallStack* stack, int stacksize, const char* name);
	typedef void (*BSModuleFunction)(Instance*);
}

#endif