#ifndef BROMSCRIPT_VARIABLE_INCLUDED
#define BROMSCRIPT_VARIABLE_INCLUDED

#include "SIF.h"
#include "Misc.h"

namespace BromScript {
	class Variable
	{
	public:
		static int GetCount();

		enum VariableType {
			Null, String, Bool, Number, Table, Function, Class, Userdata = 9
		};

		Variable(void);
		~Variable(void);
		void* Copy();

		VariableType Type;
		Scratch::CString Key;
		void* Value;

		int Using;
		bool IsCpp;
		BromScript::Userdata* CppData;
		bool DeleteOnDestruct;
		bool RegisteredInGC;
	};
}

#endif